Attribute VB_Name = "DMO_VBX"
Option Explicit

Rem ******* Define global constants for the demo program
Global Const MAX_FORMS = 100 ' this demo handles 100 forms
Global Const MAX_FIELDS = 30 ' the demo data files have 30 fields max

Global Const CHECKED = 1     ' button checked
Global Const UNCHECKED = 0   ' button not checked

Global DlgResult As Long   ' result from a dialog box call
Global DlgInt    As Long  ' to pass data to a dialog box

Global ErrorCode As Long   ' error code

Rem ******** Define global variables ******************
Global FormName(100) As String   ' form name array
Global FormFile(100) As String   ' form file name array
Global CurFormFile   As String   ' selected form file name
Global TotalForms As Long     ' total forms in the listbox
Global NewReport As Long      ' index of the new report in the list box
Global CurDataFile As String     ' current data file
Global TempDataFile As String    ' temporary data file
Global BackupFile  As String     ' backup file name
Global KeyField As Long       ' field id of the key field (customer id field)

Type TypeDataFile             ' stores name and total fields for each data file
    name As String '* 13          ' data file name
    TotalFields As Long    ' total fields in the data file
End Type

Global DataFile As TypeDataFile ' Names and total fields for each data file

Type TypeDataField
     ShortName As String '* 15  ' field short name
     FullName As String '* 35   ' full name
     width As Long           ' field width in number of characters
     type  As Long           ' field types, see TYPE_ constants in the REP.BAS file
     DecPlaces As Long       ' number of integer places for a numeric field
     RadioGroup As Long      ' group number for radion group fields
     NumData As Long            ' current numeric data if this field is of numeric type
     DblData As Double          ' current double data
     TextData As String         ' current string data
End Type

Global DataField(30) As TypeDataField ' store field information for each field for both files


