VERSION 5.00
Object = "{B1B4E863-BA69-11D0-B585-500300000500}#1.0#0"; "foc.ocx"
Begin VB.Form Form1 
   Caption         =   "Form Plus Designer Demo"
   ClientHeight    =   4140
   ClientLeft      =   4095
   ClientTop       =   2130
   ClientWidth     =   6690
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4140
   ScaleWidth      =   6690
   Begin VB.PictureBox Picture1 
      Appearance      =   0  'Flat
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   615
      Left            =   120
      ScaleHeight     =   585
      ScaleWidth      =   465
      TabIndex        =   0
      Top             =   3120
      Visible         =   0   'False
      Width           =   495
   End
   Begin FOCLib.Foc Foc1 
      Height          =   735
      Left            =   120
      TabIndex        =   1
      Top             =   2040
      Width           =   735
      _Version        =   65536
      _ExtentX        =   1296
      _ExtentY        =   1296
      _StockProps     =   0
      DesignMode      =   0   'False
      Standalone      =   -1  'True
      ShowMenu        =   -1  'True
   End
   Begin VB.Menu edit 
      Caption         =   "&Edit"
   End
   Begin VB.Menu Run 
      Caption         =   "&Run"
   End
   Begin VB.Menu Exit 
      Caption         =   "&Exit"
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

' This funtion displays the current record value.  If the 'initialize' argument
' is true then an initialized record is show
Sub ShowRecord(Initialize As Long)
   Dim i As Long
   Dim temp As Long

   For i = 0 To DataFile.TotalFields - 1
      If (Initialize) Then
          DataField(i).NumData = 0
          DataField(i).DblData = 0
          DataField(i).TextData = ""
      End If
      temp = FrsSetFieldData(Foc1.hFrsWnd, "", i, DataField(i).NumData, DataField(i).DblData, DataField(i).TextData, False)
   Next i
  
   temp = FrsRepaint(Foc1.hFrsWnd, PAINT_WIN)

End Sub

'  This function reads a record for the given key
Function ReadRecord(CustId As String)
   Dim iFile As Long

   ReadRecord = False ' initialize the return value
   
   'open the file
   iFile = 1                ' file number
   Open CurDataFile For Binary Access Read As #iFile

   ' read records sequentially from the input file
   Do While ExtractNextRecord(iFile)
      If DataField(KeyField).TextData = CustId Then
         ReadRecord = True
         Close iFile
         Exit Function
      End If
   Loop

   Close iFile
   
End Function

'  This function adds (op="A"), updates (op="U"), or delete (op="D") a record
Function WriteRecord(CustId As String, op As String)
   Dim oFile As Long
   Dim iFile As Long
   Dim RecordFound As Long
   Dim added As Long
   Dim updated As Long
   Dim deleted As Long
   Dim continue As Long
   Dim CurKeyField As String
   Dim SaveField(30) As TypeDataField
   Dim i As Long
   Dim result As Long
   Dim status As Long
   Dim WriteThisRecord As Long

   ' initialize the flags
   RecordFound = False ' initialize the return value
   added = False
   updated = False
   deleted = False
   result = False
   
   'open original file for reading
   iFile = 1                ' input number
   Open CurDataFile For Binary Access Read As #iFile

   oFile = 2                ' output file
   Open TempDataFile For Output Access Write As #oFile

   ' read records sequentially from the input file and write to the output file
   Do While True
      RecordFound = ExtractNextRecord(iFile)
      If (RecordFound Or (op = "A" And added = False)) Then continue = True Else continue = False
      If Not continue Then Exit Do

      CurKeyField = DataField(KeyField).TextData
      WriteThisRecord = True

      ' add a record
      If (op = "A" And (Not added) And (CurKeyField >= CustId Or RecordFound = False)) Then
         ' get the current field values from the screen
         For i = 0 To DataFile.TotalFields - 1
            If RecordFound Then SaveField(i) = DataField(i) ' make a copy

            DataField(i).TextData = Space$(300) ' allocate enough space for the text field
            status = FrsGetFieldData(Foc1.hFrsWnd, "", i, DataField(i).NumData, DataField(i).DblData, DataField(i).TextData)
            If status = 0 Then
               DataField(i).NumData = 0 'This field may not be on the form use initialized values
               DataField(i).DblData = 0
               DataField(i).TextData = ""
            End If
            DataField(i).TextData = DiscardNull(DataField(i).TextData) ' remove the terminating NULL character which the dll inserts
         Next i
         ' write this record
         If Not WriteCurRecord(oFile) Then GoTo END_READ
             
         ShowRecord (True)
         added = True

         If Not RecordFound Then Exit Do  ' all record copied
         
         ' now write the currently read record
         For i = 0 To DataFile.TotalFields - 1
            DataField(i) = SaveField(i)
         Next i
      
      ElseIf (op = "U" And (Not updated) And CurKeyField = CustId) Then
         'Update a record
         For i = 0 To DataFile.TotalFields - 1
            DataField(i).TextData = Space$(300) ' allocate enough space for the text field
            status = FrsGetFieldData(Foc1.hFrsWnd, "", i, DataField(i).NumData, DataField(i).DblData, DataField(i).TextData)
            DataField(i).TextData = DiscardNull(DataField(i).TextData) ' remove the terminating NULL character which the dll inserts
         Next i
         updated = True

      ElseIf (op = "D" And CurKeyField = CustId) Then
         'Delete a record
         WriteThisRecord = False
         ShowRecord (True)  ' show a blank record
         deleted = True
      End If

      ' write the current record
      If WriteThisRecord Then
         If Not WriteCurRecord(oFile) Then GoTo END_READ
      End If

   Loop

   If (added Or deleted Or updated) Then result = True

END_READ:

   Close iFile
   Close oFile

   ' backup the current file and rename the temp file as the current data file
   If (result) Then
      FileCopy CurDataFile, BackupFile
      FileCopy TempDataFile, CurDataFile
   End If

   WriteRecord = result
   
End Function

'  This function reads the next record
Function ReadNextRecord(CustId As String)
   Dim iFile As Long

   ReadNextRecord = False ' initialize the return value
   
   'open the file
   iFile = 1                ' file number
   Open CurDataFile For Binary Access Read As #iFile

   ' read records sequentially from the input file
   Do While ExtractNextRecord(iFile)
      If DataField(KeyField).TextData > CustId Then
         ReadNextRecord = True
         Close iFile
         Exit Function
      End If
   Loop

   Close iFile
End Function

'  This function reads the previous record
Function ReadPrevRecord(CustId As String)
   Dim iFile As Long
   Dim PrevCustId As String

   ReadPrevRecord = False ' initialize the return value
   
   'open the file
   iFile = 1                ' file number
   Open CurDataFile For Binary Access Read As #iFile

   ' read records sequentially from the input file to find the previous key
   PrevCustId = ""
   Do While ExtractNextRecord(iFile)
      If DataField(KeyField).TextData >= CustId Then Exit Do
      PrevCustId = DataField(KeyField).TextData   ' store previous customer id
   Loop

   Close iFile

   ' read the record corresponding to the previous key
   If PrevCustId <> "" Then ReadPrevRecord = ReadRecord(PrevCustId)

End Function

'  This function reads the values of the data fields for the current record
Function ExtractNextRecord(iFile As Long)
   Dim FieldNo As Long
   Dim ErrorCode As Long
   Dim DataValue As Variant
   
        
   For FieldNo = 0 To DataFile.TotalFields - 1
     ErrorCode = 0
     On Error GoTo ExtractRecordHandler
     Input #iFile, DataValue
     On Error GoTo 0
     If ErrorCode Then
        ExtractNextRecord = False
        Exit Function
     End If

     ' store the value in the structure
     If DataField(FieldNo).type = TYPE_TEXT Then
         DataField(FieldNo).TextData = DataValue
     ElseIf DataField(FieldNo).type = TYPE_DBL Then
         DataField(FieldNo).DblData = DataValue
     ElseIf DataField(FieldNo).type = TYPE_RADIO Or DataField(FieldNo).type = TYPE_CHECKBOX Then
         If DataValue = "Y" Or DataValue = "y" Then
            DataField(FieldNo).NumData = 1
         Else
            DataField(FieldNo).NumData = 0
         End If
     Else
         DataField(FieldNo).NumData = DataValue
     End If
   
   Next FieldNo
  
   ExtractNextRecord = True
   Exit Function

ExtractRecordHandler:
   ErrorCode = Err
   Resume Next

End Function

'  This function write the current record to the output file.
Function WriteCurRecord(oFile As Long)
   Dim FieldNo As Long
   Dim ErrorCode As Long
   Dim rec As String
   
   ' build a string containing field values
   rec = ""
             
   For FieldNo = 0 To DataFile.TotalFields - 1
     If FieldNo > 0 Then rec = rec + ","   ' add a field delimiter

     ' store the value in the structure
     If DataField(FieldNo).type = TYPE_TEXT Then
         rec = rec + Chr$(34) + DataField(FieldNo).TextData + Chr$(34)
     ElseIf DataField(FieldNo).type = TYPE_DBL Then
         rec = rec + Str(DataField(FieldNo).DblData)
     ElseIf DataField(FieldNo).type = TYPE_RADIO Or DataField(FieldNo).type = TYPE_CHECKBOX Then
         If DataField(FieldNo).NumData Then rec = rec + "Y" Else rec = rec + "N"
     Else
         rec = rec + Str(DataField(FieldNo).NumData)
     End If
   Next FieldNo

   Print #oFile, rec
  
   WriteCurRecord = True
End Function

Private Sub edit_Click()
   Dim temp As Long
   Dim FileName As String
   Dim EditingForm As Long

   EditingForm = True
   Call GetFormSelection(CurFormFile, EditingForm) 'select a report template to edit

   If DlgResult < 0 Then Exit Sub
   
   ' Show the form designer window
   FrmEdit1.Show 1

   
End Sub

Private Sub Exit_Click()
   Unload Form1
End Sub

Private Sub Form_Load()
    Dim temp As Long
    Dim i As Long
    
    ' set the demo data file names and read the field names
    CurDataFile = "customer.db"
    TempDataFile = "customer.tmp"  'used during the update of the customer.db file
    BackupFile = "customer.bu"     'backup file name
    
    KeyField = 0                 ' field id of the key field (customer id field)

    DataFile.name = "CUSTOMER"
    ReadFields

    ' load the customer logo bitmap
    Picture1.Picture = LoadPicture("LOGO.BMP")

End Sub



'  This function returns the form files found in the
'  current directory.  It also reads each file to get
'  the report description from the file
'
Private Sub GetFormFiles(wildcard As String)
    Dim FileName As String
    Dim iFile As Long
    Dim FormHdr As TypeFormHdr

    FileName = Dir(wildcard, 0)
    iFile = 1                ' file number

    Do While FileName <> ""
    
       ' oprn and read the file header
       Open FileName For Binary Access Read As #iFile

       ErrorCode = 0
       On Error GoTo ErrorGetFormFiles
       Get #iFile, 1, FormHdr
       On Error GoTo 0
       
       If ErrorCode = 0 And TotalForms < MAX_FORMS Then   ' add to the list
          If FormHdr.FormSign = FORM_SIGN Then
            FormName(TotalForms) = FormHdr.name
            FormFile(TotalForms) = FileName
            TotalForms = TotalForms + 1
          End If
       End If
    
       Close iFile

       ' get the next file
       FileName = Dir        ' get the next file

    Loop

    Exit Sub

ErrorGetFormFiles:
    ErrorCode = Err
    Resume Next

End Sub

'  This routine displays the form template available in
'  the current directory and lets use select a file to
'  edit.
'
Private Sub GetFormSelection(FileName As String, FormEdit As Long)

    FileName = ""        ' initialize the file name
    TotalForms = 0       ' total form files

    Call GetFormFiles("*.FIC") ' accumulate the files with the .FP extension

    ' add new report option to form selection
    If FormEdit Then
       NewReport = TotalForms ' index of the new form option
       TotalForms = TotalForms + 1
       FormName(NewReport) = "New Form"
       FormFile(NewReport) = ""
    End If

    FrmEdit.Show 1

    If DlgResult >= 0 Then FileName = FormFile(DlgResult)

End Sub

'  This routine reads the field definition file for the
'  specified file and extracts the individual field names
'  and field properties.
'
Private Sub ReadFields()
   Dim FileName As String
   Dim TextLine As String
   Dim CharReturn As String
   Dim CurLen As Long
   Dim FieldNo As Long
   Dim LineIdx As Long
   Dim FieldType As String
   Dim iFile As Long
   

   FieldNo = 0
   DataFile.TotalFields = 0

   ' open the field definition file
   FileName = DataFile.name + ".DF" 'field definition file
   iFile = 1
   Open FileName For Input Access Read As #iFile

READ_LINE:

    ErrorCode = 0
    On Error GoTo ErrorHandler
    Input #iFile, DataField(FieldNo).ShortName, DataField(FieldNo).width, FieldType, DataField(FieldNo).DecPlaces
    On Error GoTo 0
    If ErrorCode Then
       Close iFile
       Exit Sub
    End If

    ' construct other fields
    DataField(FieldNo).FullName = DataFile.name + "->" + DataField(FieldNo).ShortName

    If FieldType = "T" Then DataField(FieldNo).type = TYPE_TEXT
    If FieldType = "N" Then DataField(FieldNo).type = TYPE_NUM
    If FieldType = "F" Then DataField(FieldNo).type = TYPE_DBL
    If FieldType = "D" Then DataField(FieldNo).type = TYPE_DATE
    If FieldType = "C" Then DataField(FieldNo).type = TYPE_CHECKBOX
    If FieldType = "B" Then DataField(FieldNo).type = TYPE_PUSHBUTTON
    If FieldType = "P" Then DataField(FieldNo).type = TYPE_PICT
    If Mid$(FieldType, 1, 1) = "R" Then
       DataField(FieldNo).type = TYPE_RADIO
       DataField(FieldNo).RadioGroup = Mid$(FieldType, 2, 1)
    End If

    ' increment the field no
    FieldNo = FieldNo + 1
    DataFile.TotalFields = FieldNo

    GoTo READ_LINE

ErrorHandler:
    ErrorCode = Err
    Resume Next

End Sub

' This event is fired by the ReportExecutor when it needs
' your application to draw a picture.  This routine calls
' the FvbGetPictureInfo function to get the report device
' context, picture id, and rectangle locaton and size where
' the picture is to be drawn. This function also returns
' the file and field id for the picture field (this demo
' program does not use these two fields).
'
' This demo program draw different part of the same bitmap
' for different picture id.
'
Private Sub Foc1_DrawPicture()
   Dim PictInfo As TypePict
   Dim temp As Long
   Dim PictWidth As Long
   Dim PictX As Long
   Dim PictY As Long
   Dim PictHeight As Long
   Dim PictFile As String
   
   ' get the report device context and picture rectangle
   temp = FvbGetPictureInfo(Foc1.hWnd, PictInfo)
   
   ' specify part of the bitmap to print as a percentage of the width and height
   If PictInfo.PictId < 1 Then PictInfo.PictId = 1
   If PictInfo.PictId > 10 Then PictInfo.PictId = 10
 
   PictX = (PictInfo.PictId - 1) * 10  'starting X location
   PictWidth = 10               'always print only 10 percent of the bitmap
   PictY = 0
   PictHeight = 100             ' print the entire height

   ' The following statment uses the FvbDrawBitmap function
   ' to draw a part of the logo.bmp file.  The logo.bmp
   ' bitmap file is loaded into the 'Picture1' control.
   ' The 'AutoSize' property of the picture control MUST
   ' be TRUE so that the control does not clip the
   ' bitmap.

   temp = FvbDrawBitmap(Foc1.hWnd, Picture1.hWnd, Picture1.Image, PictX, PictY, PictWidth, PictHeight)
   
    
End Sub

' This event is used to prompt user for data entries
' for the fields which have FLAG_CUSTOM_DATA flag
' set.  The x,y,width,and height are the location and size
' of the field on the screen.  These values can be used
' to align your dialog box to the field on the form.
' The x,y,width, and height are given in pixel values.
Private Sub Foc1_EnterData(ByVal x As Long, ByVal y As Long, ByVal width As Long, ByVal height As Long)
    Dim field As TypeField
    Dim temp As Long
    Dim rating As String
    Dim name As String
    
    Foc1.result = False    'initialize to false result
    
    ' get the current field structure
    temp = FvbGetFieldInfo(Foc1.hWnd, field)
    name = DiscardNull(field.name)
    If name <> "CUSTOMER->RATING" Then Exit Sub
    
    ' get the current value for the rating
    rating = Space$(5) ' allocate enough space for rating
    temp = FrsGetFieldData(Foc1.hFrsWnd, "", field.FieldId, 0, 0, rating)
    rating = DiscardNull(rating)
    
    If rating = "A" Then
       DlgInt = 0
    ElseIf rating = "B" Then
       DlgInt = 1
    ElseIf rating = "C" Then
       DlgInt = 2
    Else
       DlgInt = 3
    End If
    
    ' show the ratings list box for the user to select
    FrmRating.Show 1    ' select customer rating
    If DlgResult < 0 Then Exit Sub
    
    If DlgResult = 0 Then
      rating = "A"
    ElseIf DlgResult = 1 Then
      rating = "B"
    ElseIf DlgResult = 2 Then
      rating = "C"
    Else
      rating = "X"
    End If
    
    temp = FrsSetFieldData(Foc1.hFrsWnd, "", field.FieldId, 0, 0, rating, True)
    
    Foc1.result = True ' initialize the event result to True

End Sub


'This even is called in the 'run' mode after users
'enters some data into a data field.
Private Sub Foc1_VerifyData()
    Dim field As TypeField
    Dim NumData As Long
    Dim status As Long
    Dim temp As Long
    Dim DblData As Double
    Dim CustId As String

    ' get the current field structure
    temp = FvbGetFieldInfo(Foc1.hWnd, field)

    Foc1.result = True ' initialize the event result to True
    
    If field.source = SRC_SYS Then
       ' get the value of key field (customer id)
       CustId = Space$(8) ' allocate enough space for the customer id field
       status = FrsGetFieldData(Foc1.hFrsWnd, "CUSTOMER->CUST_ID", 0, NumData, DblData, CustId)
       If status = 0 Then
          temp = FrsShowMessage(Foc1.hFrsWnd, "Customer Id Field Missing!")
          Foc1.result = False   ' return the false result
       End If
       CustId = DiscardNull(CustId) 'DLL adds a NULL to a string variable, remove it here
       
       ' Process for each system button click
       If field.SysIdx = SYS_FIND_NEXT Then
          If Not ReadNextRecord(CustId) Then
             temp = FrsShowMessage(Foc1.hFrsWnd, "No More Customers Found!")
             Foc1.result = False
             Exit Sub
          End If
          ShowRecord (False)
          
       ElseIf field.SysIdx = SYS_FIND_PREV Then
          ' process the 'find previous' system button
          If Not ReadPrevRecord(CustId) Then
             temp = FrsShowMessage(Foc1.hFrsWnd, "No More Customers Found!")
             Foc1.result = False
             Exit Sub
          End If
          ShowRecord (False)
          
       ElseIf field.SysIdx = SYS_VIEW_DATA Then
          ' View the data for the current customer
          If Not ReadRecord(CustId) Then
             temp = FrsShowMessage(Foc1.hFrsWnd, "Invalid Customer Id!")
             Foc1.result = False
             Exit Sub
          End If
          ShowRecord (False)
          
       ElseIf field.SysIdx = SYS_ADD_KEY Then
          ' Add a customer key
          If CustId = "" Then
             temp = FrsShowMessage(Foc1.hFrsWnd, "Blank Customer Id Not Allowed!")
             Foc1.result = False
             Exit Sub
          End If
          ' check if the customer id already exists
          If ReadRecord(CustId) Then
             temp = FrsShowMessage(Foc1.hFrsWnd, "This Customer Id already Exists!")
             Foc1.result = False
             Exit Sub
          End If

          If Not WriteRecord(CustId, "A") Then
             temp = FrsShowMessage(Foc1.hFrsWnd, "Error adding Customer Id!")
             Foc1.result = False
             Exit Sub
          End If

          temp = FrsShowMessage(Foc1.hFrsWnd, "Customer Record Added")

       ElseIf field.SysIdx = SYS_VERIFY_KEY Then
          ' Verify that customer key
          If ReadRecord(CustId) Then
             temp = FrsShowMessage(Foc1.hFrsWnd, "Customer Record Found")
          Else
             temp = FrsShowMessage(Foc1.hFrsWnd, "Customer Record Not Found")
          End If
          
       ElseIf field.SysIdx = SYS_UPDATE_DATA Then
          ' Update a record
          If Not ReadRecord(CustId) Then
             temp = FrsShowMessage(Foc1.hFrsWnd, "This Customer does not Exist in the Data File!")
             Foc1.result = False
             Exit Sub
          End If
          
          If Not WriteRecord(CustId, "U") Then
             temp = FrsShowMessage(Foc1.hFrsWnd, "Update Not Successful!")
             Foc1.result = False
             Exit Sub
          End If

          temp = FrsShowMessage(Foc1.hFrsWnd, "Record Updated")

       ElseIf field.SysIdx = SYS_DELETE_DATA Then
          ' delete a record
          If Not ReadRecord(CustId) Then
             temp = FrsShowMessage(Foc1.hFrsWnd, "This Customer does not Exist in the Data File!")
             Foc1.result = False
             Exit Sub
          End If
          
          If Not WriteRecord(CustId, "D") Then
             temp = FrsShowMessage(Foc1.hFrsWnd, "Delete Not Successful!")
             Foc1.result = False
             Exit Sub
          End If

          temp = FrsShowMessage(Foc1.hFrsWnd, "Record Deleted")


       End If
    End If
   
End Sub

Private Sub Run_Click()
   Dim temp As Long
   Dim FileName As String
   Dim EditingForm As Long
    

   EditingForm = False
   Call GetFormSelection(CurFormFile, EditingForm) 'select a report template to edit

   If DlgResult < 0 Then Exit Sub     ' a form not selected
   
   Foc1.ReadFile = CurFormFile
   
End Sub
